  subroutine rdquerry_minerals(nopr,iout,indir,outdir,lstrn,iset,&
  lset,llset,nlines,wcm,wavelength,rndat,ridat,iwave)

! ******
! Read in the data from the netCDF file

! ****
! Will use netCDF f90 routines
  use netcdf

! param1.inc gives the maximum size of indices and extinction vectors
  include 'param1.inc'

! ****
! See rdinoutdir.f90
  character(len=60) :: indir,outdir
  integer :: nopr,iout,iset

! See main.f90
  integer :: nlines,iwave
  real :: wcm(nwavemax),wavelength(nwavemax)
  real :: rndat(nwavemax),ridat(nwavemax)
  character(len=100) :: lstrn,lset,filnm

! Used here
  integer,parameter :: ndat=396,ncomp=4
  integer :: id1,istat,noprf,mset,i1,i2
  integer :: idwcm,idwave,idrn,idri
  integer :: start(1),count(1),stride(1)
  integer :: nclay,nillite,nkaolin,nmont
  integer :: ntext,n70
  real :: wcmdat(ndat),wavedat(ndat)
  real :: rnval(ndat),rival(ndat)
! real :: temps(mtempmax)
  character(len=30) :: fil
  character (len=16) :: files(ncomp),llset

! ***
! Read in the data from the netCDF file
   lset=lstrn

! ***
! The input netCDF file
!     '123456789012345678901234567890'
  fil='querry_minerals.nc            '

! Obtain the full pathname of the input netCDF file
   noprf=0
  call getfilnm(noprf,iout,fil,indir,filnm)
  if (noprf .eq. 1) then
   stop
  end if

! ***
! Open the netCDF file
  istat=nf90_open(filnm,nf90_nowrite,id1)
   call handle(iout,istat)

  if (nopr .eq. 1) then
   write(iout,fmt=100) id1,filnm
   100 format(/,2x,"rdquerry_minerals: id1,filnm ",i8,2x,a100)
  end if

! ***
! Get dimension ids (work with variables part of ncdump)
  istat=nf90_inq_varid(id1,'ntext',idntext)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'n70',idn70)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nclay',idnclay)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nillite',idnillite)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nkaolin',idnkaolin)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nmont',idnmont)
   call handle(iout,istat)

! *****
! Get the dimensions
  istat=nf90_get_var(id1,idnclay,nclay)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idnillite,nillite)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idnkaolin,nkaolin)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idnmont,nmont)
   call handle(iout,istat)

  istat=nf90_get_var(id1,idntext,ntext)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idn70,n70)
   call handle(iout,istat)
  
  if (nopr .eq. 1) then
   write(iout,fmt=110) nclay,nillite,nkaolin,nmont
   110 format(/,2x,"nclay,nillite,nkaolin,nmont ",/,&
   2x,4(1x,i4))
   write(iout,fmt=120) ntext,n70
   120 format(/,2x,"ntext,n70",/,&
   2x,2(1x,i4))
  end if

! ***
! Obtain the listing of the compounds
! Will ask the user to choose which compound to work with

! The different compositions
!          '1234567890123456'
  files(1)='Clay            '
  files(2)='Illite          '
  files(3)='Kaolin          '
  files(4)='Montrillite     '

! *
! Write out the compounds included in the netCDF file
  write(0,fmt=140)
  140 format(2x," Will select mset value for a specific compound")
  write(0,fmt=145)
  145 format(2x," i, compound")

  do i=1,ncomp
   write(0,fmt=150) i,files(i)
   150 format(2x,i3,2x,a16)
  end do

  write(0,fmt=160)
  160 format(2x,"Specify mset (1-4) e.g. mset=2 for Illite ")

  read(5,*) mset
  mset=int(mset)

! The compound string
  llset=files(mset)

  write(0,fmt=170) mset,llset
  170 format(2x," mset,llset ",i4,2x,a16)

! ***
! Obtain the specific indices

   if (mset .eq. 1) then 
     nlines=nclay
    istat=nf90_inq_varid(id1,'wcmclay',idwcm)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'wmicclay',idwave)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rnclay',idrn)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'riclay',idri)
     call handle(iout,istat)
   end if

   if (mset .eq. 2) then
     nlines=nillite
    istat=nf90_inq_varid(id1,'wcmillite',idwcm)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'wmicillite',idwave)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rnillite',idrn)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'riillite',idri)
     call handle(iout,istat)
   end if

   if (mset .eq. 3) then
     nlines=nkaolin
    istat=nf90_inq_varid(id1,'wcmkaolin',idwcm)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'wmickaolin',idwave)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rnkaolin',idrn)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rikaolin',idri)
     call handle(iout,istat)
   end if

   if (mset .eq. 4) then 
     nlines=nmont
    istat=nf90_inq_varid(id1,'wcmmont',idwcm)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'wmicmont',idwave)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rnmont',idrn)
     call handle(iout,istat)
    istat=nf90_inq_varid(id1,'rimont',idri)
     call handle(iout,istat)
   end if

  if (nopr .eq. 1) then
   write(0,fmt=190) nlines,idwcm,idwave,idrn,idri
   write(iout,fmt=190) nlines,idwcm,idwave,idrn,idri
   190 format(/,2x,"nlines, idwcm,idwave,idrn,idri ",/,&
   2x,1(1x,i4),2x,4(1x,i4))
  end if 

! ****
!  Read in the data
   start(1)=1
   count(1)=nlines
   stride(1)=1
  istat=nf90_get_var(id1,idwcm,wcmdat,start,count,stride)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idwave,wavedat,start,count,stride)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idrn,rnval,start,count,stride)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idri,rival,start,count,stride)
   call handle(iout,istat)

! ****
! Exit define mode
  istat=nf90_enddef(id1)

! Close the data set
  istat=nf90_close(id1)

! *****
! Put values into the output arrays
  do i=1,nlines
   wcm(i)=wcmdat(i)
   wavelength(i)=wavedat(i)
   rndat(i)=rnval(i)
   ridat(i)=rival(i)
  end do

! *****
  if (nopr .eq. 1) then
    write(iout,fmt=800) mset,files(mset)
    800 format(/,2x,"rdquerry_minerals: work with mset, files(mset)",/,&
    2x,i3,2x,a16)
    write(iout,fmt=840)
    840 format(2x,"rdquerry_minerals: i,wcm,wavelength,rndat,ridat")
   do i=1,nlines 
    write(iout,fmt=850) i,wcm(i),wavelength(i),rndat(i),ridat(i)
    850 format(2x,i4,2(1x,f10.4),1p,2(1x,e10.3))
   end do
  end if

! ******
  return
  end


